/*====================================================================
  Ҫ
  1.MCU:AT89S52оƬAT89C52
  2.:12MHz
  ܣ๦DS1302ʱ
 ====================================================================*/
#include <reg52.h>
#include <intrins.h>

#define uchar unsigned char
#define uint  unsigned int

sbit    dis_bit1=P2^7;//ܿƿ
sbit    dis_bit2=P2^6;//ܿƿ
sbit    dis_bit3=P2^4;//ܿƿ
sbit    dis_bit4=P2^3;//ܿƿ
sbit    dis_bit5=P2^1;//ܿƿ
sbit    dis_bit6=P2^0;//ܿƿ
sbit    led1_bit=P2^2;//ʱLEDĿƿ
sbit    led2_bit=P2^5;//ʱLEDĿƿ
sbit    s1_bit=P1^0;  //S1ƿ
sbit    s2_bit=P1^1;  //S2ƿ
sbit    s3_bit=P1^2;  //S3ƿ
sbit    speak=P3^7;   //ƿ
sbit    clk_ds1302=P3^6;//DS1302ʱ
sbit    io_ds1302=P3^5;//DS1302Ĵ
sbit    rest_ds1302=P3^4;
#define smg_data    P0//ݿ

void  delay_3us();//3USʱ
void  delay_50us(uint t);//ʱ50*T΢
void  display1(uchar dis_data);//1ʾӳ
void  display2(uchar dis_data);//2ʾӳ
void  display3(uchar dis_data);//3ʾӳ
void  display4(uchar dis_data);//4ʾӳ
void  display5(uchar dis_data);//5ʾӳ
void  display6(uchar dis_data);//6ʾӳ
void  init_t0();//ʱ0ʼ
void  dis_led();//LED
void  judge_s1();//S1
void  judge_s2();//S2
void  judge_s3();//S3
void  dis(uchar s6,uchar s5,uchar s4,uchar s3,uchar s2,uchar s1);//ʾӳ
void  dis_san(uchar s6,uchar s5,uchar s4,uchar s3,uchar s2,uchar s1,uchar san);//˸ʾӳ
void  judge_dis();//ʾ
void  judge_clock();//ʾ
void  set_ds1302();//ʱ
void  get_ds1302();//ȡǰʱ

void  w_1byte_ds1302(uchar t);//DS1302дһֽڵ
uchar r_1byte_ds1302();//DS1302һֽڵ

//ܶ
const uchar tabl1[16]={0xc0,0xf9,0xa4,0xb0,0x99,0x92,
                       // 0  1    2    3    4    5
                       0x82,0xf8,0x80,0x90,0x86,0x87,0xFF,
                       //6   7     8    9     E    T   B
                       0xc6,0xbf,0xff};
                        //    C      -
const uchar tabl3[]={0x00,0x01,0x01,0x02,0x03,0x03,0x04,0x04,0x05,0x06,0x06,0x07,0x08,0x08,0x09,0x09}; 
uchar t0_crycle;
uchar hour_count,minute_count,second_count,msecond_count;
uchar clock_hour,clock_minute;
uchar countdown_second;
uchar countdown_hour,countdown_minute;
uchar clock_en;//ӹرպͿı־10ر
uchar flag1,second_flag,zancun1,zancun2,zancun3;
uchar zancun4,zancun5,zancun6;
uchar clock_flag,countdown_flag;
uchar msecond_minute,msecond_second,msecond_msecond,msecond_flag;//ز
uint  speak_count;
uchar temp_flag;
uchar tab23[3];//={0x40,0x59,0x23,0x28,0x11,0x06,0x09};//ϵʱĬϵʱ
//
void main()
{
    P3=0x00;
    flag1=0;    
    zancun3=0;
    msecond_minute=0;//زΪ0
    msecond_second=0;
    msecond_msecond=0;
    speak=1;//رշ
    speak_count=0;
    clock_hour=0;
    clock_minute=0;
    clock_flag=0;
    countdown_flag=0;//ʱ־λΪ0
    clock_en=0;//ʱĬϹر
    init_t0();
    TR0=1;//
   // set_ds1302();//DS1302ĳʼʱ
   //ʼдʾĳ
    while(1)
    {
      get_ds1302();
      judge_dis();//ʾ
      judge_s1();
      judge_s2();
      judge_s3();
      judge_clock();//Ӵ
    }
}
void timer0() interrupt 1
{
	TH0=(65536-50000)/256;
	TL0=(65536-50000)%256;
	t0_crycle++;
	if(t0_crycle==2)// 0.1
	{
	  t0_crycle=0;
      msecond_flag=1;
	  msecond_count++;
      if(msecond_count==10)//1
      { 
        msecond_count=0;
        second_flag=1;
      }    
	}
}
//**************************************************
//ʾ
void  judge_dis()
{     
    if(flag1==0)
    {
         zancun4=hour_count&0xf0;
         zancun4>>=4;
         zancun5=minute_count&0xf0;
         zancun5>>=4;
         zancun6=second_count&0xf0;
         zancun6>>=4;
         dis(zancun4,hour_count&0x0f,zancun5,minute_count&0x0f,zancun6,second_count&0x0f);
         dis_led();
         if(zancun1==5)zancun1=0;
     
    }
    if(flag1!=0)
    {
       switch(flag1)
       {
           case 1:
                dis(5,10,11,1,12,12);//ʾSET1
                led1_bit=1;
                led2_bit=1;
                break;
           case 2:
                dis(5,10,11,2,12,12);//ʾSET2
                break;
           case 3:
                dis(5,10,11,3,12,12);//ʾSET3
                break;
           case 4:
                dis(5,10,11,4,12,12);//ʾSET4
                break;
           case 5:
                dis(5,10,11,5,12,12);//ʾSET5
                break;
           case 6:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,12,1);
                break;
           case 7:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,12,2);
                break;
           case 8:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,12,3);
                break;
           case 9://޸ʱ䣬ʱλλ˸
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,12,4);
                break;
           case 10://޸ӣСʱʮλ˸
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,zancun3,1);
                break;
           case 11://޸ӣСʱλ˸
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,zancun3,2);
                break;
           case 12://޸ӣСʱʮλ˸
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,zancun3,3);
                break;
           case 13://޸ӣСʱλ˸
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,zancun3,4);
                break;
           case 14://޸ӵĿ
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,12,zancun3,6);
                break;
           case 15:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,zancun3/10,zancun3%10,1);
                break;
           case 16:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,zancun3/10,zancun3%10,2);
                break;
           case 17:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,zancun3/10,zancun3%10,3);
                break;
           case 18:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,zancun3/10,zancun3%10,4);
                break;
           case 19:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,zancun3/10,zancun3%10,5);
                break;
           case 20:
                dis_san(zancun1/10,zancun1%10,zancun2/10,zancun2%10,zancun3/10,zancun3%10,6);
                break;
           case 21:
                if(second_flag==1)
                {
                    second_flag=0;
                    countdown_second--;
                    if(countdown_second==255)
                    {
                        countdown_second=59;
                        countdown_minute--;
                        if(countdown_minute==255)
                        {
                            countdown_minute=59;
                            countdown_hour--;
                            if(countdown_hour==255)
                            {
                               flag1=22;
                               countdown_minute=0;
                               countdown_hour=0;
                               countdown_second=0;
                               countdown_flag=1;
                            }
                        }
                    }
                    
                }
                dis(countdown_hour/10,countdown_hour%10,countdown_minute/10,countdown_minute%10,countdown_second/10,countdown_second%10);//
                break;
           case 22:
                if(countdown_flag>0 && countdown_flag<7)
                {
                   speak=0;
                   if(second_flag==1)
                   {
                       second_flag=0;
                       countdown_flag++;
                   }
                }
                else 
                {
                   speak=1;
                }
                 dis(countdown_hour/10,countdown_hour%10,countdown_minute/10,countdown_minute%10,countdown_second/10,countdown_second%10);//
                break;
            case 23:
                dis(msecond_minute/10,msecond_minute%10,msecond_second/10,msecond_second%10,msecond_msecond%10,12);
                break;
            case 24:
                if(msecond_flag==1)
                {
                     msecond_flag=0;
                     msecond_msecond++;
                     if(msecond_msecond==10)
                     {
                         msecond_msecond=0; 
                         msecond_second++;
                         if(msecond_second==60)
                         {
                           msecond_second=0;
                           msecond_minute++;
                           if(msecond_minute==100)
                           {
                             msecond_minute=99;
                             flag1=23;
                           }
                         }
                     }
                }
                dis(msecond_minute/10,msecond_minute%10,msecond_second/10,msecond_second%10,msecond_msecond%10,12);
                break;
            case 25:
                dis(zancun3/10,zancun3%10,zancun2/10,zancun2%10,zancun1/10,zancun1%10);
                break;
            default:
                break;
        }
    }
}
//**************************************************
//S1
void  judge_s1()
{
    s1_bit=1;//IOΪ1׼վ
    if(s1_bit==0)//жǷа
    {
        delay_50us(1);// ʱȥе
        if(s1_bit==0)
        {
           switch(flag1)
           {
               case 0:
               case 1:
               case 2:
               case 3:
               case 4:
               case 6:
               case 7:
               case 8:
               case 10:
               case 11:
               case 12:
               case 13:
               case 15:
               case 16:
               case 17:
               case 18:
               case 19:
                    flag1++;
                    break;
               case 9:
                    flag1=6;
                    break;
               case 14:
                    flag1=10;
                    break;
               case 20:
                    flag1=15;
                    break;
               case 5:
               case 21:
               case 22:
               case 23://ϵͳ״̬λ
               case 24://ϵͳ״̬λ
               case 25://ϵͳӼλ
                    flag1=0;
                    zancun1=0;
                    zancun2=0;
                    zancun3=0;
                    break;
                default:
                    break;
           }           
           while(s1_bit==0)
           {
              judge_dis();
           }//ȴͷ 
        }
    }
}
//**************************************************
//S2
void  judge_s2()
{
    s2_bit=1;//IOΪ1׼վ
    if(s2_bit==0)//жǷа
    {
        delay_50us(1);// ʱȥе
        if(s2_bit==0)
        {
           switch (flag1)
           {
              case 1: //ʾSET1״̬°S2޸ʱ
                 flag1=6;
                 zancun4=hour_count&0xf0;
                 zancun4>>=4;
                 zancun6=hour_count&0x0f;
                 zancun1=zancun4*10+zancun6;
                 //zancun1=hour_count;
                 zancun5=minute_count&0xf0;
                 zancun5>>=4;
                 zancun6=minute_count&0x0f;
                 zancun2=zancun5*10+zancun6;
                 //  zancun2=minute_count;
                 break;
              case 2://ʾSET2״̬°S2
                 zancun1=clock_hour;
                 zancun2=clock_minute;
                 flag1=10;
                 break; 
              case 6://޸ʱСʱʮλ״̬°S2
              case 7://޸ʱСʱλ״̬°S2
              case 8://޸ʱӷʮλ״̬°S2
              case 9://޸ʱӷӸλ״̬°S2
                 //zancun4=zancun1/10;

                 tab23[2]=zancun1/10*16+zancun1%10;
                  
                 //zancun5=zancun2&0xf0;
                 //zancun5>>=4;
                 tab23[1]=zancun2/10*16+zancun2%10;
                 hour_count=tab23[2];
                 minute_count=tab23[1];
                 second_count=0;
                 tab23[0]=0;
                 set_ds1302();//DS1302ĳʼʱ
                 flag1=0;
                 break;
              case 10://޸Сʱʮλ״̬°S2
              case 11://޸Сʱλ״̬°S2
              case 12://޸ӷʮλ״̬°S2
              case 13://޸ӷӸλ״̬°S2
              case 14://޸ʹ״̬°S2
                 clock_hour=zancun1;
                 clock_minute=zancun2;
                 clock_en=zancun3;
                 flag1=0;
                 break;
              case 3:
                 flag1=15;
                 zancun1=countdown_hour;
                 zancun2=countdown_minute;
                 zancun3=countdown_second;
                 break;
              case 15:
              case 16:
              case 17:
              case 18:
              case 19:
              case 20:
                 countdown_hour=zancun1;
                 countdown_minute=zancun2;
                 countdown_second=zancun3;
                 flag1=21;
                 countdown_flag=0;
                 break;
              case 22:
                 flag1=21;
                 break;
              case 21:
                 flag1=22;
                 break;
              case 4:
                 flag1=23;//ͣ
                 msecond_minute=0;
                 msecond_second=0;
                 msecond_msecond=0;
                 break;
              case 23:
                 flag1=24;
                 break;
              case 24:
                 flag1=23;
                 break;
              case 5:
                 flag1=25;//ģʽ
                 break;
              default:
                 break;
                 
           }   
           while(s2_bit==0)
           {
              judge_dis();
           }//ȴͷ 
        }
    }
}
//**************************************************
//S3
void  judge_s3()
{
    s3_bit=1;//IOΪ1׼վ
    if(s3_bit==0)//жǷа
    {
        delay_50us(1);// ʱȥе
        if(s3_bit==0)
        {
           switch (flag1)
           {
             
              case 6://޸ʱСʱʮλ
                 zancun1+=10;
                 if(zancun1>=24)zancun1=zancun1%10;
                 break;
              case 7://޸ʱСʱĸλ
                 zancun1=zancun1/10*10+(zancun1%10+1)%10;
                 if(zancun1>=24)zancun1=20;
                 break;
              case 8://޸ʱӵʮλ
                 zancun2+=10;
                 if(zancun2>=60)zancun2-=60;
                 break;
              case 9://޸ʱӵĸλ
                 zancun2=zancun2/10*10+(zancun2%10+1)%10;
                 break;
              case 10://޸Сʱʮλ
                 zancun1+=10;
                 if(zancun1>=24)zancun1=zancun1%10;
                 break;
              case 11://޸Сʱĸλ
                 zancun1=zancun1/10*10+(zancun1%10+1)%10;
                 if(zancun1>=24)zancun1=20;
                 break;
              case 12://޸ӷӵʮλ
                 zancun2+=10;
                 if(zancun2>=60)zancun2-=60;
                 break;
              case 13://޸ӷӵĸλ
                 zancun2=zancun2/10*10+(zancun2%10+1)%10;
                 break;
              case 14:
                 zancun3^=1;
                 break;
              case 15://޸ĵʱСʱʮλ
                 zancun1+=10;
                 if(zancun1>=100)zancun1-=100;
                 break;
              case 16: //޸ĵʱСʱĸλ
                 zancun1=zancun1/10*10+(zancun1%10+1)%10;
                 break;
              case 17://޸ĵʱӵʮλ
                 zancun2+=10;
                 if(zancun2>=60)zancun2-=60;
                 break;
              case 18: //޸ĵʱӵĸλ
                 zancun2=zancun2/10*10+(zancun2%10+1)%10;
                 break;
              case 19://޸ĵʱʮλ
                 zancun3+=10;
                 if(zancun3>=60)zancun3-=60;
                 break;
              case 20: //޸ĵʱĸλ
                 zancun3=zancun3/10*10+(zancun3%10+1)%10;
                 break;
              case 21:
              case 22://
                 countdown_hour=zancun1;
                 countdown_minute=zancun2;
                 countdown_second=zancun3;
                 flag1=21;
                 break;
              case 23:
              case 24://λ
                 flag1=24;
                 msecond_minute=0;
                 msecond_second=0; 
                 msecond_msecond=0;
                 break;
              case 25:
                 zancun1++;
                 if(zancun1==100)
                 {
                     zancun1=0;
                     zancun2++;
                     if(zancun2==100)
                     {
                       zancun2=0;
                       zancun3++;
                     }
                 }
                 break;
              default:
                 break;
           }   
           while(s3_bit==0)
           {
              judge_dis();
           }//ȴͷ 
        }
    }
}
//****************************************
//ʾ
void  judge_clock()
{
    zancun4=hour_count&0xf0;
    zancun4>>=4;
    zancun6=hour_count&0x0f;
    zancun4*=10;
    zancun4+=zancun6;

    zancun5=minute_count&0xf0;
    zancun5>>=4;
    zancun6=minute_count&0x0f;
    zancun5*=10;
    zancun5+=zancun6;

    if(clock_hour==zancun4 && clock_minute==zancun5)
    {
         if(clock_en==1 && clock_flag==0)
         {          
              speak_count=0;//
              clock_flag=1;
              speak_count=0;
         }
    }
    else
    {
     clock_flag=0;
    }
    if(clock_flag==1 && speak_count<400)
    {
       
        if(msecond_count<=5)
        {
           speak=0;
           speak_count++;
        }
        else
        {
          speak=1;
    
        }
    }
    else
    {
        speak=1;
    }
}
//****************************************
////˸ʾӳ
void  dis_san(uchar s6,uchar s5,uchar s4,uchar s3,uchar s2,uchar s1,uchar san)
{    
     if(san==1)
     {
        if(msecond_count<5)
        {
           display1(s6);
        } 
     }
     else
     {
         display1(s6);
     }
     if(san==2)
     {
        if(msecond_count<5)
        {
           display2(s5);
        } 
     }
     else
     {
         display2(s5);
     }
     if(san==3)
     {
        if(msecond_count<5)
        {
           display3(s4);
        } 
     }
     else
     {
         display3(s4);
     }
     if(san==4)
     {
        if(msecond_count<5)
        {
           display4(s3);
        } 
     }
     else
     {
         display4(s3);
     }
     if(san==5)
     {
        if(msecond_count<5)
        {
           display5(s2);
        } 
     }
     else
     {
         display5(s2);
     }
     if(san==6)
     {
        if(msecond_count<5)
        {
           display6(s1);
        } 
     }
     else
     {
         display6(s1);
     }
}
//****************************************
//ʱʾ
void  dis(uchar s6,uchar s5,uchar s4,uchar s3,uchar s2,uchar s1)
{
     display1(s6);
     display2(s5);
     display3(s4); 
     display4(s3);
     display5(s2);
     display6(s1); 
}
//********************************************************************************************
void init_t0()
{
   	TMOD=0x01;//趨ʱʽ1ʱʱ50
	TH0=(65536-50000)/256;
	TL0=(65536-50000)%256;
	EA=1;//ж
	ET0=1;//ʱ0ж
	t0_crycle=0;//ʱжϴԪ
}
//**************************************************
//LED
void  dis_led()
{ 
     if(msecond_count<5)
     {
         led1_bit=1;
         led2_bit=1;
     }
     else
     {
         led1_bit=0;
         led2_bit=0;
     }
}
//***************************************************************
//ܣ1ʾ1
void display6(uchar dis_data)
{  
   smg_data=tabl1[dis_data];//ʾ
   dis_bit6=0;//
   delay_50us(40);
   dis_bit6=1;
}
//***************************************************************
//ܣ1ʾ1
void display5(uchar dis_data)
{  
   smg_data=tabl1[dis_data];//ʾ
   dis_bit5=0;//
   delay_50us(40);
   dis_bit5=1;
}
//***************************************************************
//ܣ1ʾ1
void display4(uchar dis_data)
{  
   smg_data=tabl1[dis_data];//ʾ
   dis_bit4=0;//
   delay_50us(40);
   dis_bit4=1;
}//***************************************************************
//ܣ1ʾ1
void display3(uchar dis_data)
{  
   smg_data=tabl1[dis_data];//ʾ
   dis_bit3=0;//
   delay_50us(40);
   dis_bit3=1;
}
//***************************************************************
//ܣ1ʾ1
void display1(uchar dis_data)
{  
   smg_data=tabl1[dis_data];//ʾ
   dis_bit1=0;//
   delay_50us(40);
   dis_bit1=1;
}
//***************************************************************
//ܣ1ʾ1
void display2(uchar dis_data)
{  
   smg_data=tabl1[dis_data];//ʾ
   dis_bit2=0;//
   delay_50us(40);
   dis_bit2=1;
}
//**************************************************************************************************
//ƣvoid delay_50US(unsigned int t)
//ܣ ʱ50*t(us)
void delay_50us(uint t)
{
  unsigned char j; 
  for(;t>0;t--) 
  {
    for(j=19;j>0;j--);
  }
} 
//*******************************************************************************
//3΢ʱ
void delay_3us()
{ 
  ;
  ; 
}
//;##############################################################################
//;ӳw_1byte_ds1302
//;ܣ    DS1302дһֽڵ
void w_1byte_ds1302(uchar t)
{
  uchar i;
  for(i=0;i<8;i++)
  {
    if(t & 0x01)
     {io_ds1302=1;}
    else
     {io_ds1302=0;}
    clk_ds1302=1;
    delay_3us();
    delay_3us();
    clk_ds1302=0;
    delay_3us();
    delay_3us();
    t>>=1;
  }  
}
//;########################################################################
//;ӳr_1byte_ds1302()
//;ܣ    DS1302һֽڵ
uchar r_1byte_ds1302()
{ 
  uchar i,temp11=0;
  io_ds1302=1;//IOΪ1׼
  for(i=0;i<8;i++)
  {
    temp11>>=1;
    if(io_ds1302) temp11 |= 0x80;
    clk_ds1302=1;
    delay_3us();
    delay_3us();
    clk_ds1302=0;
    delay_3us();
  } 
  return(temp11);
}  
//;#################################################################################
//;ӳsetbds1302
//;ܣ   DS1302ʼʱ,ʱ
void set_ds1302()
{ 
  uchar i,j;
  rest_ds1302=0;
  delay_3us();
  clk_ds1302=0;
  delay_3us();
  rest_ds1302=1;
  delay_3us();
  w_1byte_ds1302(0x8e);//д
  delay_3us();
  w_1byte_ds1302(0x00);//дر
  clk_ds1302=1;
  delay_3us();
  rest_ds1302=0;
  for(i=0,j=0x80;i<7;i++,j+=2)
  {
    rest_ds1302=0;
    delay_3us();
    clk_ds1302=0;
    delay_3us();
    rest_ds1302=1;
    delay_3us();
    w_1byte_ds1302(j);
    delay_3us();
    w_1byte_ds1302(tab23[i]);
    delay_3us();
    delay_3us();
    clk_ds1302=1;
    delay_3us();
    rest_ds1302=0;
    delay_3us();
    delay_3us();
  }
  rest_ds1302=0;
  delay_3us();
  clk_ds1302=0;
  delay_3us();
  rest_ds1302=1;
  delay_3us();
  w_1byte_ds1302(0x8e);
  delay_3us();
  w_1byte_ds1302(0x80);
  clk_ds1302=1;
  delay_3us();
  rest_ds1302=0;
  delay_3us();
}  
//;#################################################################-------
//;ӳget1302
void get_ds1302()
{ 
   uchar temp11[7],i,j;
   for(i=0;i<7;i++)
   {temp11[i]=0;}
   for(i=0,j=0x81;i<7;i++,j+=2)
   {  
    rest_ds1302=0;
    delay_3us();
    clk_ds1302=0;
    delay_3us();
    rest_ds1302=1;
    delay_3us();
    w_1byte_ds1302(j);
    temp11[i]=r_1byte_ds1302();
    delay_3us();
    clk_ds1302=1;
    delay_3us();
    rest_ds1302=0;
    delay_3us();
  }
  if(temp11[0]!=0xff)
  {second_count=temp11[0];}
  if(temp11[1]!=0xff)// ֤
  {minute_count=temp11[1];}
  if(temp11[2]!=0xff)//֤
  {hour_count=temp11[2];}
 // date=temp[3];
  //month=temp[4];
 // week=temp[5];
  //year=temp[6];
} 